Index: lib/TWiki/Access.pm
===================================================================
--- lib/TWiki/Access.pm	(revision 1767)
+++ lib/TWiki/Access.pm	(working copy)
@@ -35,44 +35,39 @@
 
 use strict;
 
-use vars qw(
-    %allGroups @processedGroups
-);
+# hash (indexed on group name) of hashes (indexed on users)
+use vars qw( %allGroups );
 
-# =========================
 =pod
 
 ---++ initializeAccess()
-| Description: | Basic module initialization, called from TWiki::initialize |
+Basic module initialization, called from TWiki::initialize
 
 =cut
 
 sub initializeAccess
 {
     %allGroups = ();
-    @processedGroups = ();
 }
 
-# =========================
-# Are there any security restrictions for this Web
-# (ignoring settings on individual pages).
 =pod
 
 ---++ sub permissionsSet (  $web  )
 
-Not yet documented.
+Are there any security restrictions for this Web
+(ignoring settings on individual pages).
 
 =cut
 
 sub permissionsSet
 {
     my( $web ) = @_;
-    
+
     my $permSet = 0;
-    
+
     my @types = qw/ALLOW DENY/;
     my @actions = qw/CHANGE VIEW RENAME/;
-    
+
     OUT: foreach my $type ( @types ) {
         foreach my $action ( @actions ) {
             my $pref = $type . "WEB" . $action;
@@ -83,11 +78,10 @@
             }
         }
     }
-    
+
     return $permSet;
 }
 
-# =========================
 =pod
 
 ---++ checkAccessPermission( $action, $user, $text, $topic, $web ) ==> $ok
@@ -106,14 +100,12 @@
     my( $theAccessType, $theUserName,
         $theTopicText, $theTopicName, $theWebName ) = @_;
 
-#AS 2001-11-04 see Codev.UnchangeableTopicBug
     if ( $TWiki::doSuperAdminGroup && 
-	 $TWiki::superAdminGroup ) {
-	if ( &userIsInGroup( $theUserName, $TWiki::superAdminGroup ) ) {
-	    return 1;
-	}
+         $TWiki::superAdminGroup ) {
+        if ( userIsInGroup( $theUserName, $TWiki::superAdminGroup )) {
+            return 1;
+        }
     }
-#/AS
 
     $theAccessType = uc( $theAccessType );  # upper case
     if( ! $theWebName ) {
@@ -121,67 +113,46 @@
     }
     if( ! $theTopicText ) {
         # text not supplied as parameter, so read topic
-        $theTopicText = &TWiki::Store::readWebTopic( $theWebName, $theTopicName );
+        $theTopicText = TWiki::Store::readWebTopic( $theWebName, $theTopicName );
     }
-    ##&TWiki::writeDebug( "checkAccessPermission: Type $theAccessType, user $theUserName, topic $theTopicName" );
 
     # parse the " * Set (ALLOWTOPIC|DENYTOPIC)$theAccessType = " in body text
-    my @denyList = ();
-    my @allowList = ();
+    my %deny;
+    my %allow;
     foreach( split( /\n/, $theTopicText ) ) {
         if( /^\s+\*\sSet\s(ALLOWTOPIC|DENYTOPIC)$theAccessType\s*\=\s*(.*)/ ) {
             if( $2 ) {
                 my $allowOrDeny = $1;        # "ALLOWTOPIC" or "DENYTOPIC"
-                my @tmpList = map { getUsersOfGroup( $_ ) }
-                              prvGetUserList( $2 );
-                ##my $tmp = join( ', ', @tmpList );
-                ##&TWiki::writeDebug( "  Topic $allowOrDeny$theAccessType: {$tmp}" );
+                my %tmp = _parseUserList( $2, 1 );
                 if( $allowOrDeny eq "DENYTOPIC" ) {
-                    @denyList = @tmpList;
+                    %deny = %tmp;
                 } else {
-                    @allowList = @tmpList;
+                    %allow = %tmp;
                 }
             }
         }
     }
-    
+
     # if empty, get access permissions from preferences
-    if( ! @denyList ) {
-        my $tmpVal = &TWiki::Prefs::getPreferencesValue( "DENYWEB$theAccessType", $theWebName );
-        @denyList  = map { getUsersOfGroup( $_ ) }
-                     prvGetUserList( $tmpVal );
-        ##my $tmp = join( ', ', @denyList );
-        ##&TWiki::writeDebug( "  Prefs DENYWEB$theAccessType: {$tmp}" );
+    unless( %deny ) {
+        my $tmpVal =
+          TWiki::Prefs::getPreferencesValue( "DENYWEB$theAccessType",
+                                             $theWebName );
+        %deny = _parseUserList( $tmpVal, 1 );
     }
-    if( ! @allowList ) {
-        my $tmpVal = &TWiki::Prefs::getPreferencesValue( "ALLOWWEB$theAccessType", $theWebName );
-        @allowList  = map { getUsersOfGroup( $_ ) }
-                      prvGetUserList( $tmpVal );
-        ##my $tmp = join( ', ', @allowList );
-        ##&TWiki::writeDebug( "  Prefs ALLOWWEB$theAccessType: {$tmp}" );
-    }
 
-    # access permission logic
-    if( @denyList ) {
-        if( grep { /^$theUserName$/ } @denyList  ) {
-            # user is on deny list
-            ##&TWiki::writeDebug( "  return 0, user is on deny list" );
-            return 0;
-        }
+    unless( %allow ) {
+        my $tmpVal =
+          TWiki::Prefs::getPreferencesValue( "ALLOWWEB$theAccessType",
+                                             $theWebName );
+        %allow  = _parseUserList( $tmpVal, 1 );
     }
-    if( @allowList ) {
-        if( grep { /^$theUserName$/ } @allowList  ) {
-            # user is on allow list
-            ##&TWiki::writeDebug( "  return 1, user is on allow list" );
-            return 1;
-        } else {
-            # user is not on allow list
-            ##&TWiki::writeDebug( "  return 0, user is not on allow list" );
-            return 0;
-        }
-    }
+
+    return 0 if( %deny && $deny{$theUserName}  );
+
+    return $allow{$theUserName} if ( %allow );
+
     # allow is undefined, so grant access
-    ##&TWiki::writeDebug( "  return 1, allow is undefined" );
     return 1;
 }
 
@@ -196,19 +167,22 @@
 
 sub getListOfGroups
 {
-    my $text = &TWiki::Search::searchWeb(
-         "inline"        => "1",
-         "search"        => "Set GROUP =",
-         "web"           => "all",
-         "topic"         => "*Group",
-         "type"          => "regex",
-         "nosummary"     => "on",
-         "nosearch"      => "on",
-         "noheader"      => "on",
-         "nototal"       => "on",
-         "noempty"       => "on",
-	 "format"	 => "\$web.\$topic",
-     );
+    my $text =
+      TWiki::Search::searchWeb
+          (
+           #_callback      => undef,
+           inline          => 1,
+           "search"        => "Set GROUP =",
+           "web"           => "all",
+           "topic"         => "*Group",
+           "type"          => "regex",
+           "nosummary"     => "on",
+           "nosearch"      => "on",
+           "noheader"      => "on",
+           "nototal"       => "on",
+           "noempty"       => "on",
+           "format"	 => "\$web.\$topic",
+          );
 
     my ( @list ) =  split ( /\n/, $text );	
     return @list;
@@ -228,12 +202,11 @@
 {
     my( $theUserName ) = @_;
 
-    my $userTopic = prvGetWebTopicName( $TWiki::mainWebname, $theUserName );
+    my $userTopic = _getWebTopicName( $TWiki::mainWebname, $theUserName );
     my @grpMembers = ();
     my @listOfGroups = getListOfGroups();
     my $group;
 
-	&TWiki::writeDebug("Checking [$userTopic]");
     foreach $group ( @listOfGroups) {
         if ( userIsInGroup ( $userTopic, $group )) {
 	    	push ( @grpMembers, $group );
@@ -247,12 +220,11 @@
 =pod
 
 ---++ userIsInGroup( $user, $group ) ==> $ok
-| Description:        | Check if user is a member of a group |
+Check if user is a member of a group. If a topic which is
+not a group is specified, checks if it is the users topic.
 | Parameter: =$user=  | Remote WikiName, e.g. "Main.PeterThoeny" |
 | Parameter: =$group= | Group name, e.g. "Main.EngineeringGroup" |
 | Return:    =$ok=    | 1 user is in group, 0 if not |
-| TODO: | what are we checking if we are not specifying a Group? |
-| | more detailed documentation@! |
 
 =cut
 
@@ -260,54 +232,37 @@
 {
     my( $theUserName, $theGroupTopicName ) = @_;
 
-    my $usrTopic = prvGetWebTopicName( $TWiki::mainWebname, $theUserName );
-    my $grpTopic = prvGetWebTopicName( $TWiki::mainWebname, $theGroupTopicName );
+    my $usrTopic = _getWebTopicName( $TWiki::mainWebname, $theUserName );
+    my $grpTopic = _getWebTopicName( $TWiki::mainWebname, $theGroupTopicName );
     my @grpMembers = ();
 
     if( $grpTopic !~ /.*Group$/ ) {
         # not a group, so compare user to user
-        push( @grpMembers, $grpTopic );
-    } elsif( ( %allGroups ) && ( exists $allGroups{ $grpTopic } ) ) {
-        # group is allready known
-        @grpMembers = @{ $allGroups{ $grpTopic } };
-    } else {
-        @grpMembers = prvGetUsersOfGroup( $grpTopic, 1 );
+        return ( $grpTopic eq $usrTopic );
     }
+    unless ( exists $allGroups{$grpTopic} ) {
+        getUsersOfGroup( $grpTopic );
+    }
 
-    my $isInGroup = grep { /^$usrTopic$/ } @grpMembers;
-    return $isInGroup;
+    return 0 unless exists( $allGroups{$grpTopic} );
+
+    return $allGroups{$grpTopic}{$usrTopic};
 }
 
-# =========================
 =pod
 
 ---++ getUsersOfGroup( $group ) ==> @users
-| Description:         | Get all members of a group; groups are expanded recursively |
-| Parameter: =$group=  | Group topic name, e.g. "Main.EngineeringGroup" |
-| Return:    =@users=  | List of users, e.g. ( "Main.JohnSmith", "Main.JaneMiller" ) |
+Get all members of a group; groups are expanded recursively
+Return list of users, e.g. ( "Main.JohnSmith", "Main.JaneMiller" )
+| =$group=  | Group topic name, e.g. "Main.EngineeringGroup" |
+| =$processedGroups= | Internal use only; pass undef |
 
 =cut
 
 sub getUsersOfGroup
 {
-    my( $theGroupTopicName ) = @_;
-    ##TWiki::writeDebug( "group is $theGroupTopicName" );
-    return prvGetUsersOfGroup( $theGroupTopicName, 1 );
-}
+    my( $theGroupTopicName, $processedGroups ) = @_;
 
-# =========================
-=pod
-
----++ sub prvGetUsersOfGroup (  $theGroupTopicName, $theFirstCall  )
-
-Not yet documented.
-
-=cut
-
-sub prvGetUsersOfGroup
-{
-    my( $theGroupTopicName, $theFirstCall ) = @_;
-
     my @resultList = ();
     # extract web and topic name
     my $topic = $theGroupTopicName;
@@ -317,7 +272,6 @@
         $web = $1;
         $topic = $2;
     }
-    ##TWiki::writeDebug( "Web is $web, topic is $topic" );
 
     if( $topic !~ /.*Group$/ ) {
         # return user, is not a group
@@ -325,66 +279,56 @@
     }
 
     # check if group topic is already processed
-    if( $theFirstCall ) {
-        # FIXME: Get rid of this global variable
-        @processedGroups = ();
-    } elsif( grep { /^$web\.$topic$/ } @processedGroups ) {
-        # do nothing, already processed
+    if( !defined( $processedGroups )) {
+        $processedGroups = {};
+    } elsif( $processedGroups->{"$web.$topic"} ) {
         return ();
     }
-    push( @processedGroups, "$web\.$topic" );
+    $processedGroups->{"$web.$topic"} = 1;
 
     # read topic
-    my $text = &TWiki::Store::readWebTopic( $web, $topic );
+    my $text = TWiki::Store::readWebTopic( $web, $topic );
 
+    # SMELL: what the blazes is this? Comment it out, and
+    # see what breaks.... DFP rules.
     # reset variables, defensive coding needed for recursion
-    (my $baz = "foo") =~ s/foo//;
+    #(my $baz = "foo") =~ s/foo//;
 
     # extract users
     my $user = "";
-    my @glist = ();
+    my %glist;
     foreach( split( /\n/, $text ) ) {
-        if( /^\s+\*\sSet\sGROUP\s*\=\s*(.*)/ ) {
-            if( $1 ) {
-                @glist = prvGetUserList( $1 );
-            }
+        if( /^\s+\*\sSet\sGROUP\s*\=\s*(.+)$/ ) {
+            # Note: if there are multiple GROUP assignments in the
+            # topic, the last will be taken.
+            %glist = _parseUserList( $1, 0 );
         }
     }
-    foreach( @glist ) {
+    foreach ( keys %glist ) {
         if( /.*Group$/ ) {
             # $user is actually a group
             my $group = $_;
             if( ( %allGroups ) && ( exists $allGroups{ $group } ) ) {
-                # allready known, so add to list
-                push( @resultList, @{ $allGroups{ $group } } );
+                # already known, so add to list
+                push( @resultList, keys %{$allGroups{$group}} );
             } else {
                 # call recursively
-                my @userList = prvGetUsersOfGroup( $group, 0 );
-                # add group to allGroups hash
-                $allGroups{ $group } = [ @userList ];
-                push( @resultList, @userList );
+                push( @resultList,
+                      map { $allGroups{$group}{$_} = 1; }
+                      getUsersOfGroup( $group, $processedGroups ));
             }
         } else {
             # add user to list
             push( @resultList, $_ );
         }
     }
-    ##TWiki::writeDebug( "Returning group member list of @resultList" );
     return @resultList;
 }
 
-# =========================
-=pod
-
----++ sub prvGetWebTopicName (  $theWebName, $theTopicName  )
-
-Not yet documented.
-
-=cut
-
-sub prvGetWebTopicName
+sub _getWebTopicName
 {
     my( $theWebName, $theTopicName ) = @_;
+    # SMELL: this is a hack, isn't it? What should really be going on here?
     $theTopicName =~ s/%MAINWEB%/$theWebName/go;
     $theTopicName =~ s/%TWIKIWEB%/$theWebName/go;
     if( $theTopicName =~ /[\.]/ ) {
@@ -395,26 +339,27 @@
     return $theTopicName;
 }
 
-# =========================
-=pod
-
----++ sub prvGetUserList (  $theItems  )
-
-Not yet documented.
-
-=cut
-
-sub prvGetUserList
+# Get a hash indexed by the users in a list. If expand is
+# true, recursively expand groups defined in the list to create
+# a flat has of users.
+sub _parseUserList
 {
-    my( $theItems ) = @_;
+    my( $theItems, $expand ) = @_;
     # comma delimited list of users or groups
     # i.e.: "%MAINWEB%.UserA, UserB, Main.UserC  # something else"
     $theItems =~ s/(<[^>]*>)//go;     # Remove HTML tags
     # TODO: i18n fix for user name
     $theItems =~ s/\s*([a-zA-Z0-9_\.\,\s\%]*)\s*(.*)/$1/go; # Limit list
-    my @list = map { prvGetWebTopicName( $TWiki::mainWebname, $_ ) }
-               split( /[\,\s]+/, $theItems );
-    return @list;
+    my %list;
+    foreach( split( /[\,\s]+/, $theItems )) {
+        my $e = _getWebTopicName( $TWiki::mainWebname, $_ );
+        if ( $expand ) {
+            map { $list{$_} = 1; } getUsersOfGroup( $e );
+        } else {
+            $list{$e} = 1;
+        }
+    }
+    return %list;
 }
 
 # =========================
Index: lib/TWiki/UI/Upload.pm
===================================================================
--- lib/TWiki/UI/Upload.pm	(revision 1767)
+++ lib/TWiki/UI/Upload.pm	(working copy)
@@ -38,7 +38,7 @@
   my ( $webName, $topic, $userName, $query ) = @_;
 
   my $fileName = $query->param( 'filename' ) || "";
-  my $skin = $query->param( "skin" );
+  my $skin = TWiki::getSkin();
 
   return unless TWiki::UI::webExists( $webName, $topic );
 
@@ -52,7 +52,7 @@
 
   return if TWiki::UI::isMirror( $webName, $topic );
 
-  my $wikiUserName = &TWiki::userToWikiName( $userName );
+  my $wikiUserName = &TWiki::User::userToWikiName( $userName );
   return unless TWiki::UI::isAccessPermitted( $webName, $topic,
                                             "change", $wikiUserName );
 
@@ -60,303 +60,52 @@
 
   ( $meta, $text ) = &TWiki::Store::readTopic( $webName, $topic );
   my %args = $meta->findOne( "FILEATTACHMENT", $fileName );
-  %args = ( "attr" => "", "path" => "", "comment" => "" ) if( ! % args );
+  %args = (
+           name => $fileName,
+           attr => "",
+           path => "",
+           comment => ""
+          ) if( ! % args );
 
-  if ( $args{"attr"} =~ /h/o ) {
-    $isHideChecked = "checked";
+  if ( $args{attr} =~ /h/o ) {
+      $isHideChecked = "checked";
   }
 
-  # why log attach before post is called?
+  # SMELL: why log attach before post is called?
   # FIXME: Move down, log only if successful (or with error msg?)
   # Attach is a read function, only has potential for a change
   if( $TWiki::doLogTopicAttach ) {
-    # write log entry
-    &TWiki::Store::writeLog( "attach", "$webName.$topic", $fileName );
+      # write log entry
+      TWiki::writeLog( "attach", "$webName.$topic", $fileName );
   }
-  
+
   my $fileWikiUser = "";
-  $skin = TWiki::Prefs::getPreferencesValue( "SKIN" ) unless ( $skin );
   if( $fileName && %args ) {
-    $tmpl = TWiki::Store::readTemplate( "attachagain", $skin );
-    $fileWikiUser = &TWiki::userToWikiName( $args{"user"} );
+    $tmpl = TWiki::Templates::readTemplate( "attachagain", $skin );
+    $fileWikiUser = &TWiki::User::userToWikiName( $args{"user"} );
   } else {
-    $tmpl = TWiki::Store::readTemplate( "attachnew", $skin );
+      $tmpl = TWiki::Templates::readTemplate( "attachnew", $skin );
   }
   if ( $fileName ) {
 	# must come after templates have been read
-    $atext .= TWiki::Attach::formatVersions( $webName, $topic, $fileName, %args );
+    $atext .= TWiki::Attach::formatVersions( $webName, $topic, %args );
   }
   $tmpl =~ s/%ATTACHTABLE%/$atext/go;
   $tmpl =~ s/%FILEUSER%/$fileWikiUser/go;
   $tmpl = &TWiki::handleCommonTags( $tmpl, $topic );
+  # SMELL: The following two calls are done in the reverse order in all
+  # the other handlers. Why are they done in this order here?
   $tmpl = &TWiki::Render::getRenderedVersion( $tmpl );
-  $tmpl = &TWiki::handleMetaTags( $webName, $topic, $tmpl, $meta );
+  $tmpl = TWiki::Render::renderMetaTags( $webName, $topic, $tmpl, $meta, 0 );
   $tmpl =~ s/%HIDEFILE%/$isHideChecked/go;
   $tmpl =~ s/%FILENAME%/$fileName/go;
   $tmpl =~ s/%FILEPATH%/$args{"path"}/go;
   $tmpl =~ s/%FILECOMMENT%/$args{"comment"}/go;
   $tmpl =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;   # remove <nop> and <noautolink> tags
-  TWiki::writeHeader( TWiki::getCgiQuery() );
+  TWiki::writeHeader( TWiki::getCgiQuery(), length( $tmpl ));
   print $tmpl;
 }
 
-# =========================
-# code fragment to extract pixel size from images
-# taken from http://www.tardis.ed.ac.uk/~ark/wwwis/
-# subroutines: _imgsize, _gifsize, _OLDgifsize, _gif_blockskip,
-#              _NEWgifsize, _jpegsize
-#
-# looking at the filename really sucks I should be using the first 4 bytes
-# of the image. If I ever do it these are the numbers.... (from chris@w3.org)
-#  PNG 89 50 4e 47
-#  GIF 47 49 46 38
-#  JPG ff d8 ff e0
-#  XBM 23 64 65 66
-
-
-# =========================
-sub _imgsize {
-  my( $file ) = shift @_;
-  my( $x, $y) = ( 0, 0 );
-
-  if( defined( $file ) && open( STRM, "<$file" ) ) {
-    binmode( STRM ); # for crappy MS OSes - Win/Dos/NT use is NOT SUPPORTED
-    if( $file =~ /\.jpg$/i || $file =~ /\.jpeg$/i ) {
-      ( $x, $y ) = &_jpegsize( \*STRM );
-    } elsif( $file =~ /\.gif$/i ) {
-      ( $x, $y ) = &_gifsize(\*STRM);
-    } elsif( $file =~ /\.png$/i ) {
-      ( $x, $y ) = &_pngsize(\*STRM);
-    }
-    close( STRM );
-  }
-  return( $x, $y );
-}
-
-
-# =========================
-sub _gifsize
-{
-  my( $GIF ) = @_;
-  if( 0 ) {
-    return &_NEWgifsize( $GIF );
-  } else {
-    return &_OLDgifsize( $GIF );
-  }
-}
-
-
-# =========================
-sub _OLDgifsize {
-  my( $GIF ) = @_;
-  my( $type, $a, $b, $c, $d, $s ) = ( 0, 0, 0, 0, 0, 0 );
-
-  if( defined( $GIF )              &&
-      read( $GIF, $type, 6 )       &&
-      $type =~ /GIF8[7,9]a/        &&
-      read( $GIF, $s, 4 ) == 4     ) {
-    ( $a, $b, $c, $d ) = unpack( "C"x4, $s );
-    return( $b<<8|$a, $d<<8|$c );
-  }
-  return( 0, 0 );
-}
-
-
-# =========================
-# part of _NEWgifsize
-sub _gif_blockskip {
-  my ( $GIF, $skip, $type ) = @_;
-  my ( $s ) = 0;
-  my ( $dummy ) = '';
-
-  read( $GIF, $dummy, $skip );       # Skip header (if any)
-  while( 1 ) {
-    if( eof( $GIF ) ) {
-      #warn "Invalid/Corrupted GIF (at EOF in GIF $type)\n";
-      return "";
-    }
-    read( $GIF, $s, 1 );             # Block size
-    last if ord( $s ) == 0;          # Block terminator
-    read( $GIF, $dummy, ord( $s ) ); # Skip data
-  }
-}
-
-
-# =========================
-# this code by "Daniel V. Klein" <dvk@lonewolf.com>
-sub _NEWgifsize {
-  my( $GIF ) = @_;
-  my( $cmapsize, $a, $b, $c, $d, $e ) = 0;
-  my( $type, $s ) = ( 0, 0 );
-  my( $x, $y ) = ( 0, 0 );
-  my( $dummy ) = '';
-
-  return( $x,$y ) if( !defined $GIF );
-
-  read( $GIF, $type, 6 );
-  if( $type !~ /GIF8[7,9]a/ || read( $GIF, $s, 7 ) != 7 ) {
-    #warn "Invalid/Corrupted GIF (bad header)\n";
-    return( $x, $y );
-  }
-  ( $e ) = unpack( "x4 C", $s );
-  if( $e & 0x80 ) {
-    $cmapsize = 3 * 2**(($e & 0x07) + 1);
-    if( !read( $GIF, $dummy, $cmapsize ) ) {
-      #warn "Invalid/Corrupted GIF (global color map too small?)\n";
-      return( $x, $y );
-    }
-  }
- FINDIMAGE:
-  while( 1 ) {
-    if( eof( $GIF ) ) {
-      #warn "Invalid/Corrupted GIF (at EOF w/o Image Descriptors)\n";
-      return( $x, $y );
-    }
-    read( $GIF, $s, 1 );
-    ( $e ) = unpack( "C", $s );
-    if( $e == 0x2c ) {           # Image Descriptor (GIF87a, GIF89a 20.c.i)
-      if( read( $GIF, $s, 8 ) != 8 ) {
-        #warn "Invalid/Corrupted GIF (missing image header?)\n";
-        return( $x, $y );
-      }
-      ( $a, $b, $c, $d ) = unpack( "x4 C4", $s );
-      $x = $b<<8|$a;
-      $y = $d<<8|$c;
-      return( $x, $y );
-    }
-    if( $type eq "GIF89a" ) {
-      if( $e == 0x21 ) {         # Extension Introducer (GIF89a 23.c.i)
-        read( $GIF, $s, 1 );
-        ( $e ) = unpack( "C", $s );
-        if( $e == 0xF9 ) {       # Graphic Control Extension (GIF89a 23.c.ii)
-          read( $GIF, $dummy, 6 );        # Skip it
-          next FINDIMAGE;       # Look again for Image Descriptor
-        } elsif( $e == 0xFE ) {  # Comment Extension (GIF89a 24.c.ii)
-          &_gif_blockskip( $GIF, 0, "Comment" );
-          next FINDIMAGE;       # Look again for Image Descriptor
-        } elsif( $e == 0x01 ) {  # Plain Text Label (GIF89a 25.c.ii)
-          &_gif_blockskip( $GIF, 12, "text data" );
-          next FINDIMAGE;       # Look again for Image Descriptor
-        } elsif( $e == 0xFF ) {  # Application Extension Label (GIF89a 26.c.ii)
-          &_gif_blockskip( $GIF, 11, "application data" );
-          next FINDIMAGE;       # Look again for Image Descriptor
-        } else {
-          #printf STDERR "Invalid/Corrupted GIF (Unknown extension %#x)\n", $e;
-          return( $x, $y );
-        }
-      } else {
-        #printf STDERR "Invalid/Corrupted GIF (Unknown code %#x)\n", $e;
-        return( $x, $y );
-      }
-    } else {
-      #warn "Invalid/Corrupted GIF (missing GIF87a Image Descriptor)\n";
-      return( $x, $y );
-    }
-  }
-}
-
-# =========================
-# _jpegsize : gets the width and height (in pixels) of a jpeg file
-# Andrew Tong, werdna@ugcs.caltech.edu           February 14, 1995
-# modified slightly by alex@ed.ac.uk
-sub _jpegsize {
-  my( $JPEG ) = @_;
-  my( $done ) = 0;
-  my( $c1, $c2, $ch, $s, $length, $dummy ) = ( 0, 0, 0, 0, 0, 0 );
-  my( $a, $b, $c, $d );
-
-  if( defined( $JPEG )             &&
-      read( $JPEG, $c1, 1 )        &&
-      read( $JPEG, $c2, 1 )        &&
-      ord( $c1 ) == 0xFF           &&
-      ord( $c2 ) == 0xD8           ) {
-    while ( ord( $ch ) != 0xDA && !$done ) {
-      # Find next marker (JPEG markers begin with 0xFF)
-      # This can hang the program!!
-      while( ord( $ch ) != 0xFF ) {
-        return( 0, 0 ) unless read( $JPEG, $ch, 1 );
-      }
-      # JPEG markers can be padded with unlimited 0xFF's
-      while( ord( $ch ) == 0xFF ) {
-        return( 0, 0 ) unless read( $JPEG, $ch, 1 );
-      }
-      # Now, $ch contains the value of the marker.
-      if( ( ord( $ch ) >= 0xC0 ) && ( ord( $ch ) <= 0xC3 ) ) {
-        return( 0, 0 ) unless read( $JPEG, $dummy, 3 );
-        return( 0, 0 ) unless read( $JPEG, $s, 4 );
-        ( $a, $b, $c, $d ) = unpack( "C"x4, $s );
-        return( $c<<8|$d, $a<<8|$b );
-      } else {
-        # We **MUST** skip variables, since FF's within variable names are
-        # NOT valid JPEG markers
-        return( 0, 0 ) unless read( $JPEG, $s, 2 );
-        ( $c1, $c2 ) = unpack( "C"x2, $s );
-        $length = $c1<<8|$c2;
-        last if( !defined( $length ) || $length < 2 );
-        read( $JPEG, $dummy, $length-2 );
-      }
-    }
-  }
-  return( 0, 0 );
-}
-
-# =========================
-#  _pngsize : gets the width & height (in pixels) of a png file
-#  cor this program is on the cutting edge of technology! (pity it's blunt!)
-#  GRR 970619:  fixed bytesex assumption
-#  source: http://www.la-grange.net/2000/05/04-png.html
-sub _pngsize {
-  my ($PNG) = @_;
-  my ($head) = "";
-  my($a, $b, $c, $d, $e, $f, $g, $h)=0;
-  if(defined($PNG)                              &&
-     read( $PNG, $head, 8 ) == 8                &&
-     $head eq "\x89\x50\x4e\x47\x0d\x0a\x1a\x0a" &&
-     read($PNG, $head, 4) == 4                  &&
-     read($PNG, $head, 4) == 4                  &&
-     $head eq "IHDR"                            &&
-     read($PNG, $head, 8) == 8                  ){
-    ($a,$b,$c,$d,$e,$f,$g,$h)=unpack("C"x8,$head);
-    return ($a<<24|$b<<16|$c<<8|$d, $e<<24|$f<<16|$g<<8|$h);
-  }
-  return (0,0);
-} 
-
-# =========================
-sub _addLinkToEndOfTopic
-{
-    my ( $text, $pathFilename, $fileName, $fileComment ) = @_;
-    my $fileLink = "";
-    my $imgSize = "";
-
-    if( $fileName =~ /\.(gif|jpg|jpeg|png)$/i ) {
-        # inline image
-        $fileComment = $fileName if( ! $fileComment );
-        my( $nx, $ny ) = &_imgsize( $pathFilename );
-        if( ( $nx > 0 ) && ( $ny > 0 ) ) {
-            $imgSize = " width=\"$nx\" height=\"$ny\" ";
-        }
-        $fileLink = &TWiki::Prefs::getPreferencesValue( "ATTACHEDIMAGEFORMAT" )
-                  || '   * $comment: <br />'
-                   . ' <img src="%ATTACHURLPATH%/$name" alt="$name"$size />';
-    } else {
-        # normal attached file
-        $fileLink = &TWiki::Prefs::getPreferencesValue( "ATTACHEDFILELINKFORMAT" )
-                 || '   * [[%ATTACHURL%/$name][$name]]: $comment';
-    }
-
-    $fileLink =~ s/^      /\t\t/go;
-    $fileLink =~ s/^   /\t/go;
-    $fileLink =~ s/\$name/$fileName/g;
-    $fileLink =~ s/\$comment/$fileComment/g;
-    $fileLink =~ s/\$size/$imgSize/g;
-    $fileLink =~ s/\\t/\t/go;
-    $fileLink =~ s/\\n/\n/go;
-    $fileLink =~ s/([^\n])$/$1\n/;
-
-    return "$text$fileLink";
-}
-
 =pod
 
 ---++ upload( $web, $topic, $userName, $query)
@@ -448,7 +197,7 @@
        $filePath, $localFile,
        $attName, $hideFile, $comment ) = @_;
 
-  my $wikiUserName = TWiki::userToWikiName( $userName );
+  my $wikiUserName = TWiki::User::userToWikiName( $userName );
   return ( 0 ) unless TWiki::UI::webExists( $webName, $topic );
   return ( 0 ) if TWiki::UI::isMirror( $webName, $topic );
   return ( 0 ) unless TWiki::UI::isAccessPermitted( $webName, $topic,
@@ -516,7 +265,7 @@
 
     if( $TWiki::doLogTopicUpload ) {
       # write log entry
-      TWiki::Store::writeLog( "upload", "$webName.$topic", $attName );
+      TWiki::writeLog( "upload", "$webName.$topic", $attName );
       #FIXE also do log for change property?
     }
   }
@@ -535,8 +284,8 @@
   }
 
   if( $createLink ) {
-    $filePath = TWiki::Store::getFileName( $webName, $topic, $attName );
-    $text = _addLinkToEndOfTopic( $text, $filePath, $attName, $comment );
+    $text .= TWiki::Attach::getAttachmentLink( $webName, $topic,
+                                               $attName, $meta );
   }
 
   # update topic
Index: lib/TWiki/UI/Search.pm
===================================================================
--- lib/TWiki/UI/Search.pm	(revision 1767)
+++ lib/TWiki/UI/Search.pm	(working copy)
@@ -26,6 +26,7 @@
 use strict;
 use TWiki;
 use TWiki::UI;
+use TWiki::Templates;
 
 =pod
 
@@ -83,7 +84,7 @@
     # correct string, but so what?  The pipline is the second
     # parameter to the join, and consists of the last two lines.  The
     # join takes the results of the pipeline and strings them back
-    # together, space delimited, which is exactly what &searchWikiWeb
+    # together, space delimited, which is exactly what &searchWeb
     # needs.
     # Note that mod_perl/cgi appears to use ';' as separator, whereas plain cgi uses '&'
 
@@ -95,9 +96,11 @@
     $attrWeb =~ tr/+/ /;       # pluses become spaces
     $attrWeb =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;  # %20 becomes space
 
-    &TWiki::writeHeader( $query );
-    &TWiki::Search::searchWeb(
-        "inline"        => "0",
+    TWiki::writeHeader( $query, 0);
+
+    TWiki::Search::searchWeb(
+        _callback       => \&_contentCallback,
+        inline          => 0,
         "search"        => scalar $query->param( "search" ),
         "web"           => $attrWeb,
         "topic"         => scalar $query->param( "topic" ),
@@ -127,5 +130,9 @@
     );
 }
 
+sub _contentCallback {
+    print @_;
+}
+
 1;
 
